Subject: Re: bad TSO performance in 2.6.9-rc2-BK

From: Andi Kleen <[email-masked]>
Date: Wed, 22 Sep 2004 16:00:00 +0200

On Tue, Sep 21, 2004 at 03:58:35PM -0700, David S. Miller wrote:
> On Mon, 20 Sep 2004 22:30:21 +0200
> Andi Kleen <[email-masked]> wrote:
> 
> > I see the same problem here, but it's even worse. I only get 150-200KB/s
> > sending data with scp from a fast machine with e1000 with a gigabit link. 
> > netperf also gives only 250KB/s. 
> 
> So I re-enabled TSO support in the loopback driver to try and
> reproduce this, but I can't.
> 
> There has been a lot of churn in this area so please make sure you
> are using the latest sources, all of my current TSO fixes are in
> Linus's BK tree.

I tried it with rc2bk8 again and the performance is much better (22MB/s) 
that what I got earlier with 2.6.8rc2, but still far below what 2.6.5 gets 
on the same hardware (68MB/s) 

Both tests with netperf over e1000.

> And, take the patch below and do a loopback bandwidth test before
> and after the patch is applied.  Do things slow down when loopback
> has TSO enabled just as it does for your gigabit interfaces?

Without TSO ~755MB/s, with TSO ~600-620MB/s (results seem to be a bit
variable). 

-Andi